/*! 
    \file bv_tree.h
    \brief Definition of a bounding volume tree

*/

#ifndef _BV_TREE_H
#define _BV_TREE_H

#include "base_object.h"

// FORWARD DEFINITION
class BoundingVolume;


//! A class that represents a bounding volume tree
class BVTree : public BaseObject {

 public:
  BVTree();
  virtual ~BVTree();

  void spawnBVTree(int depth);
  void flushTree();

  BoundingVolume* getBV(int index) const;
  
  void collideWith(const BVTree &tree);

  void drawBV(int currentDepth, const int depth) const;
  void drawBVPolygon(int currentDepth, const int depth) const;
  void drawBVBlended(int currentDepth, const int depth) const;

 private:
  BoundingVolume* firstElement;

};

#endif /* _BV_TREE_H */
